<script setup lang="ts">
import { useField, useForm } from 'vee-validate';
import {
  required as requiredRule,
  email as emailRule,
  min as minRule
} from '@vee-validate/rules'
import { computed, onMounted, ref } from 'vue'
import type ShippingMethod from '@/models/ShippingMethod'
import type PaymentMethod from '@/models/PaymentMethod'
import { useApi } from '@/api'
const { handleSubmit } = useForm();
const shippingMethods = ref<ShippingMethod[]>([])
const paymentMethods = ref<PaymentMethod[]>([])
const shippingMethodId = ref<number>(1)
const paymentMethodId = ref<number>(1)

const { getShippingMethods, getPaymentMethods } = useApi()
onMounted(async () => {
  [shippingMethods.value, paymentMethods.value] = await Promise.all([
    getShippingMethods(),
    getPaymentMethods()
  ])
  if(shippingMethods.value.length > 0) {
    shippingMethodId.value = shippingMethods.value[0].id
  }
  if(paymentMethods.value.length > 0) {
    paymentMethodId.value = paymentMethods.value[0].id
  }
})

const { value: firstName, errorMessage: firstNameError } = useField('First Name', requiredRule)
const { value: lastName, errorMessage: lastNameError } = useField('Last Name', requiredRule)
const { value: country, errorMessage: countryError } = useField('Country/Region', requiredRule)
const { value: city, errorMessage: cityError } = useField('Town/City', requiredRule)
const { value: street, errorMessage: streetError } = useField('Street', requiredRule)
const { value: email, errorMessage: emailError } = useField('Email Address', (value: string) => {
  return requiredRule(value) && emailRule(value)
})
const { value: phone, errorMessage: phoneError } = useField('Phone', (value: string) => {
  return requiredRule(value) && minRule(value, { length: 10 })
})

const apartment = ref('')
const notes = ref('')

const shippingPrice = computed(() => {
  console.log(shippingMethodId.value)
  const shippingMethod = shippingMethods.value.find((item: ShippingMethod) => item.id === shippingMethodId.value)
  return shippingMethod?.price.toFixed(2)
})

const onSubmit = handleSubmit(() => {
  console.log(firstName.value, lastName.value, email.value, paymentMethodId.value)
});
</script>
<template>
  <div class="axil-checkout-area axil-section-gap">
    <div class="container">
      <form class="checkout-form" @submit.prevent="onSubmit">
        <div class="row">
          <div class="col-lg-6">
            <div class="axil-checkout-billing">
              <h4 class="title mb--40">Billing details</h4>
              <div class="row">
                <div class="col-lg-6">
                  <div class="form-group">
                    <label>First Name <span>*</span></label>
                    <input
                        type="text"
                        id="first-name"
                        placeholder="Adam"
                        :class="{invalid: firstNameError}"
                        v-model="firstName"
                    >
                    <span class="invalid-feedback">{{ firstNameError }}</span>
                  </div>
                </div>
                <div class="col-lg-6">
                  <div class="form-group">
                    <label>Last Name <span>*</span></label>
                    <input
                        type="text"
                        id="last-name"
                        placeholder="John"
                        :class="{invalid: lastNameError}"
                        v-model="lastName"
                    >
                    <span class="invalid-feedback">{{ lastNameError }}</span>
                  </div>
                </div>
              </div>
              <div class="form-group">
                <label>Phone <span>*</span></label>
                <input
                    type="tel"
                    id="phone"
                    placeholder="0685839243"
                    :class="{invalid: phoneError}"
                    v-model="phone"
                >
                <span class="invalid-feedback">{{ phoneError }}</span>
              </div>
              <div class="form-group">
                <label>Email Address <span>*</span></label>
                <input
                    type="email"
                    id="email"
                    :class="{invalid: emailError}"
                    v-model="email"
                >
                <span class="invalid-feedback">{{ emailError }}</span>
              </div>
              <div class="form-group">
                <label>Country/ Region <span>*</span></label>
                <input
                    type="text"
                    id="Region"
                    :class="{invalid: countryError}"
                    v-model="country"
                >
                <span class="invalid-feedback">{{ countryError }}</span>
              </div>
              <div class="form-group">
                <label>Town/ City <span>*</span></label>
                <input
                    type="text"
                    id="town"
                    :class="{invalid: cityError}"
                    v-model="city"
                >
                <span class="invalid-feedback">{{ cityError }}</span>
              </div>
              <div class="form-group">
                <label>Street Address <span>*</span></label>
                <input
                    type="text"
                    id="address1"
                    class="mb--15"
                    placeholder="House number and street name"
                    :class="{invalid: streetError}"
                    v-model="street"
                >
                <span class="invalid-feedback">{{ streetError }}</span>
                <input type="text" v-model="apartment" id="address2" placeholder="Apartment, suite, unit, etc. (optonal)">
              </div>
              <div class="form-group">
                <label>Other Notes (optional)</label>
                <textarea v-model="notes" id="notes" rows="2"
                          placeholder="Notes about your order, e.g. speacial notes for delivery."></textarea>
              </div>
            </div>
          </div>
          <div class="col-lg-6">
            <div class="axil-order-summery order-checkout-summery">
              <h5 class="title mb--20">Your Order</h5>
              <div class="summery-table-wrap">
                <table class="table summery-table">
                  <thead>
                  <tr>
                    <th>Product</th>
                    <th>Subtotal</th>
                  </tr>
                  </thead>
                  <tbody>
                  <tr class="order-product">
                    <td>Commodo Blown Lamp <span class="quantity">x1</span></td>
                    <td>$117.00</td>
                  </tr>
                  <tr class="order-product">
                    <td>Commodo Blown Lamp <span class="quantity">x1</span></td>
                    <td>$198.00</td>
                  </tr>
                  <tr class="order-subtotal">
                    <td>Subtotal</td>
                    <td>$117.00</td>
                  </tr>
                  <tr class="order-shipping">
                    <td colspan="2">
                      <div class="shipping-amount">
                        <span class="title">Shipping Method</span>
                        <span class="amount">${{shippingPrice}}</span>
                      </div>
                      <div class="input-group" v-for="method of shippingMethods" :key="method.id">
                        <input
                            type="radio"
                            :id="`shipping${method.id}`"
                            name="shipping"
                            :value="method.id"
                            v-model="shippingMethodId"
                        >
                        <label :for="`shipping${method.id}`">{{ method.title }}(${{method.price.toFixed(2)}})</label>
                      </div>
                    </td>
                  </tr>
                  <tr class="order-total">
                    <td>Total</td>
                    <td class="order-total-amount">$323.00</td>
                  </tr>
                  </tbody>
                </table>
              </div>
              <div class="order-payment-method">
                <div class="single-payment">
                  <div class="input-group">
                    <input type="radio" id="radio4" name="payment">
                    <label for="radio4">Direct bank transfer</label>
                  </div>
                  <p>Make your payment directly into our bank account. Please use your Order ID as the payment
                    reference. Your order will not be shipped until the funds have cleared in our account.</p>
                </div>
                <div class="single-payment">
                  <div class="input-group">
                    <input type="radio" id="radio5" name="payment">
                    <label for="radio5">Cash on delivery</label>
                  </div>
                  <p>Pay with cash upon delivery.</p>
                </div>
                <div class="single-payment">
                  <div class="input-group justify-content-between align-items-center">
                    <input type="radio" id="radio6" name="payment" checked>
                    <label for="radio6">Paypal</label>
                    <img src="@/assets/images/others/payment.png" alt="Paypal payment">
                  </div>
                  <p>Pay via PayPal; you can pay with your credit card if you don’t have a PayPal account.</p>
                </div>
              </div>
              <button type="submit" class="axil-btn btn-bg-primary checkout-btn">Process to Checkout</button>
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<style scoped lang="scss">
.checkout-form {
  .invalid {
    border-color: #dc3545;
  }

  .invalid + label {
    color: #dc3545;
  }

  .invalid-feedback {
    display: block;
  }
}
</style>